//
//  Shader_LightTex.vsh
//  CityBuilder
//
//  Created by Jonathan Webb on 18/08/2011.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

//------------------------------------------------------------------------------

//#define POS_COMPRESSION_FACTOR	(16.384)
#define POS_COMPRESSION_FACTOR		(16.0)//(128.0)

//------------------------------------------------------------------------------

attribute vec4 position;
attribute vec3 normal;
attribute vec2 texCoord;

//------------------------------------------------------------------------------

uniform mat4 modelViewProjectionMatrix;
uniform mat4 lightDirectionMat;
uniform mat4 lightColorMat;
uniform vec4 animUV;

//------------------------------------------------------------------------------

varying lowp	vec4 colorVarying;
varying mediump vec2 texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    
    // Transform the position into screen space.
    vec3 posScaled = (position.xyz / POS_COMPRESSION_FACTOR);
    gl_Position = modelViewProjectionMatrix * vec4(posScaled, 1.0);
    //gl_Position = modelViewProjectionMatrix * position;

    // Decompress UVs
    //texCoordVarying = animUV.xy + texCoord;
//    texCoordVarying = animUV.xy * animUV.zw + (texCoord/1024.0);

	mediump	vec2	baseUVOffset	= fract(animUV.xy * animUV.zw);

	texCoordVarying.xy				= ((texCoord/1024.0) + baseUVOffset);

#if 1
    //colorVarying = vec4 (normal.x, normal.y, normal.z, 1.0);

    // Create the dot products for the three direction lights.
    vec4 dots = lightDirectionMat * vec4(normal, 0.0);
    
    // Clamp dots to between 0 and 1 (make sure the ambient dot is 1).
    dots = clamp (dots, 0.0, 1.0);
    dots.w = 1.0;
    
    // Apply the dots to the color matrix and copy to the output.
    colorVarying = lightColorMat * dots;
#else
    colorVarying = vec4(0.0, 0.0, 1.0, 1.0);
#endif
}

//------------------------------------------------------------------------------
