//
//  Shader_PreLitTexReflectiveWater.vsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

//#define POS_COMPRESSION_FACTOR	(16.384)
#define POS_COMPRESSION_FACTOR		(16.0)//(128.0)

//------------------------------------------------------------------------------

attribute vec4 position;

//------------------------------------------------------------------------------

uniform highp	mat4	modelViewProjectionMatrix;

//------------------------------------------------------------------------------

varying highp	vec2	texCoordVarying;	// highp needed to avoid inaccuracies in the anim uv's

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
    vec3 posScaled = (position.xyz / POS_COMPRESSION_FACTOR);
	vec4 posScaled4 = vec4(posScaled, 1.0);
	vec4 posTrans = modelViewProjectionMatrix * posScaled4;
	
	gl_Position = posTrans;

	texCoordVarying.xy = (posTrans.xy / posTrans.w);
	texCoordVarying.xy = ((texCoordVarying.xy * 0.5) + 0.5);
}

//------------------------------------------------------------------------------
